/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/********************************************************************************* 
 *     COPYRIGHT NOTICE:
 *     Copyright © 2014 Andrew Smith (GNA SERVICES INC) <Andrew@GNAServicesInc.com>
 *     All Rights Reserved.
 *
 *   This file, main.c , is part of tpad.
 *
 *   tpad is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *   tpad is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with tpad.  If not, see <http://www.gnu.org/licenses/>.
 ******************************************************************************/
////////////////////////////////////////////////////////////////////////
#include "tpad_headers.h"

////////////////////////////////////////////////////////////////////////
const static char COPPYRIGHT_NOTICE[85] = {"Copyright (C) 2014, 2015, 2016 Andrew Smith (GNA SERVICES INC) <Andrew@GNAServicesInc.com>"};
const static char LICENSE_NOTICE[700] = {"Copyright (C) 2014, 2015, 2016 Andrew Smith (GNA SERVICES INC) <Andrew@GNAServicesInc.com>\n\ntpad is free software: you can redistribute it and/or modify it\nunder the terms of the GNU General Public License as published by the\nFree Software Foundation, either version 3 of the License, or\n(at your option) any later version.\n\ntpad is distributed in the hope that it will be useful, but\nWITHOUT ANY WARRANTY; without even the implied warranty of\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\nSee the GNU General Public License for more details.\n\nYou should have received a copy of the GNU General Public License along\nwith this program.  If not, see <http://www.gnu.org/licenses/>.\n"};
////////////////////////////////////////////////////////////////////////
/* MAIN  */ 
////////////////////////////////////////////////////////////////////////

static void* ntpad(void *ptr);

extern int main(int argc, char* argv[])
{


	////////////////////////////////////////////////////////////////////////
	// Native Language Support Int
	////////////////////////////////////////////////////////////////////////
	#ifdef ENABLE_NLS
	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	#endif
	////////////////////////////////////////////////////////////////////////
	SET_BINARY_MODE(stdin);
	SET_BINARY_MODE(stdout);
	
	char* fchar = (char*) argv[1];
	pthread_t thread[argc + 1];
	gint  iThreadReturn[argc + 1];

	set_path_self(argv[0]);

	if (argc > 1){
		int i=0;
		for (i = 1; i < argc; i += 1){
		iThreadReturn[i] = pthread_create(&thread[i],
	                               NULL,
	                               ntpad,
	                               (void*) clean_path(argv[i]) );	
	pthread_detach(thread[i]);
		}
	}
	else{
		iThreadReturn[0] = pthread_create(&thread[0],
	                               NULL,
	                               ntpad,
	                               (void*) "" );

	pthread_detach(thread[0]);
	}
	
	////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////
	/* MAIN RETURN */
	////////////////////////////////////////////////////////////////////////
	return (0);
	////////////////////////////////////////////////////////////////////////
}

static void* ntpad(void *ptr){
	char* ptrargv = (char*) ptr;
	if(fork() == 0)  tpad_main(ptrargv);

  	pthread_exit( (void*) NULL );
}